import javax.swing.JTextPane;

import graph.*;

public class Breitendurchlauf extends Thread{
	private Graph bspGraph;
	private Vertex startKnoten;
	private JTextPane textArea;
	
	public Breitendurchlauf(Graph pGraph, String pStart, JTextPane pText) {
		bspGraph = pGraph;
		startKnoten = bspGraph.getVertex(pStart);
		textArea = pText;
	}
	
public String breitendurchlaufToString(List<Vertex> liste) {
    String ausgabe = "\nBreitendurchlauf\n";
	ausgabe = ausgabe+"Reihenfolge der besuchten Knoten:\n";
    liste.toFirst();
    while (liste.hasAccess()) {
      Vertex knoten = (Vertex) liste.getContent();
      ausgabe = ausgabe + knoten.getID()+ " ";
      liste.next();
    }
    return ausgabe+"\n";
  }

  public List<Vertex> breitensuche(Vertex startKnoten) {
    List<Vertex> ergebnisListe = new List<Vertex>();  
    Queue<Vertex> schlange = new Queue<Vertex>();
    startKnoten.setMark(true);
    schlange.enqueue(startKnoten);
    
    while (!schlange.isEmpty()) {
      Vertex aktuellerKnoten = (Vertex) schlange.front();
      schlange.dequeue();
      ergebnisListe.append(aktuellerKnoten);
      List<Vertex> nachbarListe = bspGraph.getNeighbours(aktuellerKnoten);
      nachbarListe.toFirst();
      while (nachbarListe.hasAccess()) {
        Vertex knoten = (Vertex) nachbarListe.getContent();
        if (!knoten.isMarked()) {
          knoten.setMark(true);  
          schlange.enqueue(knoten);
        }
        nachbarListe.next();  
      }
    }
    return ergebnisListe;
  }
  
	@Override
	public void run() {
		bspGraph.setAllVertexMarks(false);
		List<Vertex> laufListe = breitensuche(startKnoten);
		bspGraph.setAllVertexMarks(false);
		textArea.setText(textArea.getText()+breitendurchlaufToString(laufListe));
	}


}