import javax.swing.JTextPane;

import graph.*;

public class WeglaengeBacktracking{ 
	private Graph bspGraph;
	private String startKnoten;
	private String zielKnoten;
	private JTextPane textfeld;
	String weg;
	List<String> ausgabeListe;
	List<String> wegLaengen;

	public WeglaengeBacktracking(Graph pGraph, String pStart, String pZiel,  JTextPane pText) {
		bspGraph = pGraph;
		startKnoten = pStart;
		zielKnoten = pZiel;
		textfeld = pText;
		weg = "";
		ausgabeListe = new List<String>();
		wegLaengen = new List<String>();

	}

	public void run() {
		bspGraph.setAllVertexMarks(false);
		Vertex start = bspGraph.getVertex(startKnoten);
		Vertex ziel = bspGraph.getVertex(zielKnoten);
		berechneWeglaenge(start, ziel);
		textfeld.setText("Kürzester Weg Backtracking-Algorithmus\n");
		ausgabeListe.toFirst();
		wegLaengen.toFirst();
		String ausgabeString = "";
		while (ausgabeListe.hasAccess()){
			ausgabeString = ausgabeString+ausgabeListe.getContent()+"\n"+wegLaengen.getContent()+"\n";
			ausgabeListe.next();
			wegLaengen.next();
		}
		markiereKanten(ausgabeListe);
		textfeld.setText(textfeld.getText()+ausgabeString);
	}

    private void markiereKanten(List<String> wegKnoten){
    	wegKnoten.toLast();
    	String knoten = wegKnoten.getContent();
    	String id1 = knoten.substring(1, 2);
    	knoten = knoten.substring(2, knoten.length());
    	Vertex v1 = bspGraph.getVertex(id1);
    	while (!knoten.equals("")){ 
    		String id2 = knoten.substring(1, 2);
    		Vertex v2 = bspGraph.getVertex(id2);
    		Edge e = bspGraph.getEdge(v1, v2);
    		e.setMark(true);
        	knoten = knoten.substring(2, knoten.length());
        	v1 = v2;
    	}
    }
	
	
	private double berechneWeglaenge(Vertex pStart, Vertex pZiel) {
		bspGraph.setAllVertexMarks(false);
		return berechneLaenge(pStart, pZiel, 0, Double.MAX_VALUE);
	}

	private double berechneLaenge(Vertex pAktKnoten, Vertex pZiel, double pAkt,
			double pMin) {
		if (pAktKnoten == pZiel) {
			weg = weg+" "+pAktKnoten.getID();
			ausgabeListe.append(weg);
			wegLaengen.append("Weglänge: "+pAkt);
			weg = weg.substring(0, weg.length()-2);
			if (pAkt < pMin) {
				return pAkt;
			} else {
				return pMin;
			}
		} else {
			double entfernung = pMin;
			pAktKnoten.setMark(true);
            weg = weg+" " + pAktKnoten.getID();
			List<Vertex> nachbarListe = bspGraph.getNeighbours(pAktKnoten);
			nachbarListe.toFirst();
			while (nachbarListe.hasAccess()) {
				Vertex nachbar = (Vertex) nachbarListe.getContent();
				if (!nachbar.isMarked()) {
					double gewicht = bspGraph.getEdge(pAktKnoten, nachbar)
							.getWeight();
					if (pAkt + gewicht < entfernung) {
						double dist = berechneLaenge(nachbar, pZiel, pAkt
								+ gewicht, entfernung);
						if (dist < entfernung) {
							entfernung = dist;
						}
					}
				}
				nachbarListe.next();
			}
			pAktKnoten.setMark(false);
			weg = weg.substring(0, weg.length()-2);
			return entfernung;
		}
	}

}
