 
import graph.*;
public class Spannbaum {
  private Graph bspGraph;
  private String markierteKanten;

 

  public Spannbaum() {
    bspGraph = new Graph();  
    erzeugeBeispiel();
  }
  
  public void erzeugeBeispiel() {
    bspGraph.addVertex(new Vertex1("A"));
    bspGraph.addVertex(new Vertex1("B"));
    bspGraph.addVertex(new Vertex1("C"));
    bspGraph.addVertex(new Vertex1("E"));
    bspGraph.addVertex(new Vertex1("F"));
    bspGraph.addVertex(new Vertex1("G"));
    bspGraph.addVertex(new Vertex1("H"));
    bspGraph.addVertex(new Vertex1("I"));
    bspGraph.addVertex(new Vertex1("K"));
    bspGraph.addVertex(new Vertex1("L"));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("A"),bspGraph.getVertex("B"),20));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("A"),bspGraph.getVertex("G"),125));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("B"),bspGraph.getVertex("C"),30));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("B"),bspGraph.getVertex("F"),30));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("C"),bspGraph.getVertex("E"),40));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("E"),bspGraph.getVertex("F"),50));
      bspGraph.addEdge(new Edge(bspGraph.getVertex("E"),bspGraph.getVertex("K"),70));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("E"),bspGraph.getVertex("L"),30));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("F"),bspGraph.getVertex("G"),100));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("F"),bspGraph.getVertex("K"),46));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("G"),bspGraph.getVertex("K"),60));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("G"),bspGraph.getVertex("H"),15));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("G"),bspGraph.getVertex("I"),15));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("H"),bspGraph.getVertex("I"),45));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("I"),bspGraph.getVertex("K"),10));
  }
  
  public String adListenToString() {
    String ausgabe = "Adjazenzlisten \n";
    List<Vertex> knotenliste = bspGraph.getVertices();
    knotenliste.toFirst();
    while (knotenliste.hasAccess()) {
      Vertex knoten = knotenliste.getContent();
      ausgabe = ausgabe + knoten.getID()+":\t";
      List<Vertex> nachbarliste = bspGraph.getNeighbours(knoten);
      nachbarliste.toFirst();
      while (nachbarliste.hasAccess()) {
        Vertex k = nachbarliste.getContent();
        ausgabe = ausgabe + k.getID() + " "+ bspGraph.getEdge(knoten,k).getWeight()+" ";
        nachbarliste.next();
      }
      ausgabe = ausgabe + "\n";
      knotenliste.next();
    }
    return ausgabe;
  }
  
  
  private boolean hatZyklus(Vertex1 knoten, Vertex1 vorgaenger){
     boolean zyklus = false;
      if (knoten.getStatus()!=1){
          if (knoten.getStatus()==0) {
              knoten.setStatus(1);
              List<Vertex> nachfolger= bspGraph.getNeighbours(knoten);
              nachfolger.toFirst();
              while (nachfolger.hasAccess() && !zyklus){
                  Vertex1 einNachfolger = (Vertex1)nachfolger.getContent();
                  Edge kante = bspGraph.getEdge(knoten,einNachfolger);
                  if (kante!=null && kante.isMarked() && einNachfolger!=vorgaenger){
                      zyklus = hatZyklus(einNachfolger, knoten);
                  }
                  nachfolger.next();
               }
               knoten.setStatus(2);
           }     
        } else {
            zyklus = true;
          }
     return zyklus;
    }
     
  
  private List<Edge> gibAufsteigendSortiert(List<Edge> pList){
	    List<Edge> ergebnis = new List<Edge>();

	    //Alle Kanten von pList durchlaufen.
	    pList.toFirst();
	    while (pList.hasAccess()){
	      Edge aktuell = pList.getContent();

	      //Kante sortiert in die Ergebnisliste einfuegen.
	      ergebnis.toFirst();
	      while (ergebnis.hasAccess() &&  ergebnis.getContent().getWeight() < aktuell.getWeight()){
	        ergebnis.next();        
	      }
	      if (ergebnis.hasAccess()){
	        ergebnis.insert(aktuell);
	      } else {
	        ergebnis.append(aktuell);
	      }

	      pList.next();
	    }
	    return ergebnis;
	  }


	  private void resetStatus(List<Vertex> knoten){
	      knoten.toFirst();
	      while (knoten.hasAccess()){
	          Vertex1 v = (Vertex1)knoten.getContent();
	          v. setStatus(0);
	          knoten.next();
	       }
	   }
	  
	   public String spannbaumKruskal(){
	    bspGraph.setAllVertexMarks(false);
	    bspGraph.setAllEdgeMarks(false);
	    List<Edge> kantenListe = this.gibAufsteigendSortiert(bspGraph.getEdges());
	    String kantenString = "";
	    kantenListe.toFirst();
	    while (!kantenListe.isEmpty()){
	      //Aktuelle Kante wird ausgelesen.
	      Edge aktuelleKante = kantenListe.getContent();
	      Vertex[] knoten = (aktuelleKante.getVertices());
          aktuelleKante.setMark(true);
          resetStatus(bspGraph.getVertices());
          if (hatZyklus((Vertex1)knoten[0], null)){
             aktuelleKante.setMark(false);
          } else {
              kantenString = kantenString + knoten[0].getID()+" "+ knoten[1].getID()+":"+aktuelleKante.getWeight()+"\n";
          }
	      kantenListe.remove();
	    }
	    return kantenString;
	  }
	  
	  public String spannbaumPrim(Vertex startKnoten){
		    //Knotenmarkierungen des Graphen zuruecksetzen.
		    bspGraph.setAllVertexMarks(false);
		    startKnoten.setMark(true);  
		    String kantenString = "";
		    List<Edge> kanten = bspGraph.getEdges(startKnoten); 
		    //Kanten hinzufuegen, solange noch nicht alle Knoten im Graphen markiert sind.
		    while (!bspGraph.allVerticesMarked()){
		      //Minimale Kante der Kantenliste ermitteln und solche Kanten entfernen, die innerhalb der erschlossenen 
		      //Zusammenhangskomponente liegen.
		      Edge minKante = null;
		      kanten.toFirst(); 
		      Vertex[] endKnoten;
		      while (kanten.hasAccess()){
		         Edge kante = kanten.getContent();
		         endKnoten = kante.getVertices();
		        //Kante entfernen, wenn sie innerhalb der bereits erschlossenen Zusammenhangskomponente verlaeuft.
		        if (!endKnoten[0].isMarked() || !endKnoten[1].isMarked()){
		          //Auf kleinere Kante ueberpruefen.
		          if (minKante == null || kante.getWeight() < minKante.getWeight()){
		            minKante = kante;
		          }   
		        }
		        kanten.next();
		      }
		      minKante.setMark(true);
		      endKnoten = minKante.getVertices();
		      kantenString = kantenString+endKnoten[0].getID()+" "+endKnoten[1].getID()+" \n";
		      //Den Knoten ermitteln der durch die minimale Kante der Zusammenhangskomponete hinzugefuegt wird.
		      Vertex neuerKnoten = null;
		      if (endKnoten[0].isMarked()){
		        neuerKnoten = endKnoten[1];
		      } else {
		        neuerKnoten = endKnoten[0];
		      }

		      //Neu verbundenen Knoten markieren.
		      neuerKnoten.setMark(true);

		      //Mit dem neuen Knoten inzidente Kanten in die Kantenliste hinzufuegen.
		      List<Edge> neueKanten = bspGraph.getEdges(neuerKnoten);
		      neueKanten.toFirst();
		      while (neueKanten.hasAccess()){
		          kanten.append(neueKanten.getContent());
		          neueKanten.next();
		      }
		    }
		    return kantenString;
	  }

  public double berechneBaumlaenge(List<Edge> liste) {
    double summe = 0.0;
    liste.toFirst();
    while (liste.hasAccess() ) {
      Edge kante = liste.getContent();
      if (kante.isMarked()){
          summe = summe + kante.getWeight();
      }
      liste.next();
    }
    return summe;
  }
  
   public String kruskalToString(){
	  String spannbaumString= this.spannbaumKruskal();
	  double baumlaenge = this.berechneBaumlaenge(bspGraph.getEdges());
	  String text = spannbaumString+"\nGesamtlnge: "+baumlaenge;
	  return text;
   }
   
     public String primToString(String start){
	  String spannbaumString= this.spannbaumPrim(bspGraph.getVertex(start));
	  double baumlaenge = this.berechneBaumlaenge(bspGraph.getEdges());
	  String text = spannbaumString+"\nGesamtlnge: "+baumlaenge;
	  return text;
   }
}
