import java.awt.*;
import java.awt.event.*;


public class Graph_GUI extends Frame {
  // Anfang Attribute
  private TextArea textArea1 = new TextArea("", 1, 1, TextArea.SCROLLBARS_VERTICAL_ONLY);
  private Button btnWegTiefe = new Button();
  private Button btnAlle = new Button();
  private Button btnWegBreite = new Button();
  private Label label1 = new Label();
  private Label label2 = new Label();
  private TextField textField1 = new TextField();
  private TextField textField2 = new TextField();
  private Button btnGraph = new Button();
  // Ende Attribute
  private WegSuche graph1 = new WegSuche();

  public Graph_GUI(String title) {
    // Frame-Initialisierung
    super(title);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) { dispose(); }
    });
    int frameWidth = 538; 
    int frameHeight = 313;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Panel cp = new Panel(null);
    add(cp);
    // Anfang Komponenten

    textArea1.setBounds(16, 16, 355, 267);
    textArea1.setText("(Strings)");
    textArea1.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(textArea1);
    
    label1.setBounds(392, 16, 38, 20);
    label1.setText("Start");
    cp.add(label1);
    
    label2.setBounds(392, 48, 38, 20);
    label2.setText("Ziel");
    cp.add(label2);
    
    textField1.setBounds(450, 16, 62, 20);
    textField1.setText("K");
    cp.add(textField1);
    
    textField2.setBounds(450, 48, 62, 20);
    textField2.setText("H");
    cp.add(textField2);
    
    btnGraph.setBounds(378, 80, 139, 25);
    btnGraph.setLabel("Adjazenzlisten");
    btnGraph.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        btnGraph_ActionPerformed(evt);
      }
    });
    cp.add(btnGraph);
    
    btnWegTiefe.setBounds(378, 120, 139, 25);
    btnWegTiefe.setLabel("\nEin Weg");
    btnWegTiefe.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnWegTiefe_ActionPerformed(evt);
      }
    });
    btnWegTiefe.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(btnWegTiefe);
    
    btnAlle.setBounds(378, 160, 139, 25);
    btnAlle.setLabel("\nAlle Wege");
    btnAlle.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnAlle_ActionPerformed(evt);
      }
    });
    btnAlle.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(btnAlle);
    
    btnWegBreite.setBounds(378, 200, 139, 25);
    btnWegBreite.setLabel("\nEin Weg Breite");
    btnWegBreite.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnWegBreite_ActionPerformed(evt);
      }
    });
    btnWegBreite.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(btnWegBreite);
    
   
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
    textArea1.setText("");
  }

   public void btnGraph_ActionPerformed(ActionEvent evt) {
    textArea1.append(graph1.adListenToString()+"\n");
  } // end of button5_ActionPerformed
  
  public void btnWegTiefe_ActionPerformed(ActionEvent evt) {
    String s = textField1.getText();
    String z = textField2.getText();
    textArea1.append("\n"+"Ein Weg: "+"\n");
    textArea1.append(graph1.sucheWegToString(s,z)+"\n");
  }
  
  public void btnAlle_ActionPerformed(ActionEvent evt) {
    String s = textField1.getText();
    String z = textField2.getText();
    textArea1.append("\n"+"Alle Wege: "+"\n");

    textArea1.append(""+graph1.sucheAlleWegeToString(s,z)+"\n");
  }
  
  public void btnWegBreite_ActionPerformed(ActionEvent evt) {
    String s = textField1.getText();
    String z = textField2.getText();
    textArea1.append("\n"+"Ein Weg Breitensuche: "+"\n");

    textArea1.append(""+graph1.sucheWegBreiteToString(s,z)+"\n");
  }
  
 

  
 

  // Ende Methoden

  public static void main(String[] args) {
    new Graph_GUI("Graph_GUI");
  }
}
